#!/usr/bin/env python

"""Genera un video de n milisegundos a partir de una imag."""

from __future__ import division

import glob
import herrams
import os
import shutil
import sys
import tempfile

TAMANIO = (1024,768)
FPS = 20

def main(cantsegs, imag):
    tmpdir = tempfile.mkdtemp(dir='/tmp')
    name, ext = os.path.basename(imag).split(".")

    # jpg!
    if ext.lower() not in ('jpg', 'jpeg'):
        tmpimag = tempfile.mkstemp(suffix='.jpg', dir='/tmp')[1]
        cmd = 'convert %s %s' % (imag, tmpimag)
        os.system(cmd)
        imag = tmpimag

    frames = int(round(FPS * cantmseg / 1000))
    print "Cantidad de frames:  %d" % frames

    # armamos todas los frames
    av = herrams.Avance(frames)
    print "Arrancando"
    for i in xrange(frames):
        nom = "%s/comp%05d.jpg" % (tmpdir, i)
        shutil.copy(imag, nom)
        av.step()

    cmd = 'mencoder "mf://%s/*.jpg" -mf fps=%d -o tmp.avi -ovc lavc ' +\
          '-lavcopts vcodec=mjpeg'
    os.system(cmd % (tmpdir, FPS))
    cmd = "ffmpeg -i tmp.avi -target pal-dv %s.dv"
    os.system(cmd % name)

    # remove temp files
    for nomarch in glob.glob(tmpdir + "/comp?????.jpg"):
        os.remove(nomarch)
    os.remove("tmp.avi")

if __name__ == "__main__":
    if len(sys.argv) != 3:
        print "Usar  imag2video.py mseg imag"
        sys.exit()
    cantmseg = int(sys.argv[1])
    imag = sys.argv[2]
    main(cantmseg, imag)
